use Pion::lepton::Lepton;
use Pion::lepton::AntiLepton;
use Pion::baryon::Baryon;
use Pion::baryon::AntiBaryon;
use Pion::photon::Photon;

use crate::nuclide::Nuclide ;

use crate::atom::Atom;

 pub const PROTONMASS   : f64 = 1.007276466621f64      ;
 pub const NEUTRONMASS  : f64 = 1.00866491588f64       ;
 pub const ELECTRONMASS : f64 = 5.48579909070E-4       ;  
 pub const ALPHAMASS    : f64 = 4.001506179127f64      ;
 pub const TRITONMASS   : f64 = 3.01550098060002103    ;
 pub const DEUTERONMASS : f64 = 2.01355338927343374    ;
 
 pub const NEUTRINOMASS : f64 = 1.288738236E-10        ;

 #[derive(Debug,Clone)]
 pub enum Particle{
    /// Photon and frequency
     Photon(f64),
   /// Leptons including Electrons, Neutrinos, and AntiNeutrinos  
     Lepton(Lepton),
   /// AntiLeptons  
     AntiLepton(AntiLepton),
   /// Proton or Neutron  
     Baryon(Baryon),
  /// AntiBaryons   
     AntiBaryon(AntiBaryon),
 /// Alpha particle    
     Alpha(f64),
 /// Deuterium nucleus    
     Deuteron(f64),
 /// Tritium nucleus     
     Triton(f64),
 /// Elemental nucleus    
     Element(Nuclide,f64),
    // IsoElement(Isomer,f64),   
 }

